/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(SQL_DATABASE)

#include "JSDatabaseSync.h"

#include "DatabaseSync.h"
#include "ExceptionCode.h"
#include "JSDOMBinding.h"
#include "JSSQLTransactionSyncCallback.h"
#include "ScriptExecutionContext.h"
#include "URL.h"
#include <runtime/Error.h>
#include <runtime/JSString.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsDatabaseSyncPrototypeFunctionChangeVersion(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsDatabaseSyncPrototypeFunctionTransaction(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsDatabaseSyncPrototypeFunctionReadTransaction(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsDatabaseSyncVersion(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsDatabaseSyncLastErrorMessage(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);

class JSDatabaseSyncPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSDatabaseSyncPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSDatabaseSyncPrototype* ptr = new (NotNull, JSC::allocateCell<JSDatabaseSyncPrototype>(vm.heap)) JSDatabaseSyncPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSDatabaseSyncPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

/* Hash table for prototype */

static const HashTableValue JSDatabaseSyncPrototypeTableValues[] =
{
    { "version", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDatabaseSyncVersion), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "lastErrorMessage", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDatabaseSyncLastErrorMessage), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "changeVersion", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsDatabaseSyncPrototypeFunctionChangeVersion), (intptr_t) (2) },
    { "transaction", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsDatabaseSyncPrototypeFunctionTransaction), (intptr_t) (1) },
    { "readTransaction", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsDatabaseSyncPrototypeFunctionReadTransaction), (intptr_t) (1) },
};

WEBCORE_EXPORT const ClassInfo JSDatabaseSyncPrototype::s_info = { "DatabaseSyncPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSDatabaseSyncPrototype) };

void JSDatabaseSyncPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSDatabaseSyncPrototypeTableValues, *this);
}

WEBCORE_EXPORT const ClassInfo JSDatabaseSync::s_info = { "DatabaseSync", &Base::s_info, 0, CREATE_METHOD_TABLE(JSDatabaseSync) };

JSDatabaseSync::JSDatabaseSync(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<DatabaseSync> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

JSObject* JSDatabaseSync::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSDatabaseSyncPrototype::create(vm, globalObject, JSDatabaseSyncPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSDatabaseSync::getPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSDatabaseSync>(vm, globalObject);
}

void JSDatabaseSync::destroy(JSC::JSCell* cell)
{
    JSDatabaseSync* thisObject = static_cast<JSDatabaseSync*>(cell);
    thisObject->JSDatabaseSync::~JSDatabaseSync();
}

JSDatabaseSync::~JSDatabaseSync()
{
    releaseImplIfNotNull();
}

EncodedJSValue jsDatabaseSyncVersion(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSDatabaseSync* castedThis = jsDynamicCast<JSDatabaseSync*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSDatabaseSyncPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "DatabaseSync", "version");
        return throwGetterTypeError(*exec, "DatabaseSync", "version");
    }
    DatabaseSync& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.version());
    return JSValue::encode(result);
}


EncodedJSValue jsDatabaseSyncLastErrorMessage(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSDatabaseSync* castedThis = jsDynamicCast<JSDatabaseSync*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSDatabaseSyncPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "DatabaseSync", "lastErrorMessage");
        return throwGetterTypeError(*exec, "DatabaseSync", "lastErrorMessage");
    }
    DatabaseSync& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.lastErrorMessage());
    return JSValue::encode(result);
}


EncodedJSValue JSC_HOST_CALL jsDatabaseSyncPrototypeFunctionChangeVersion(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSDatabaseSync* castedThis = jsDynamicCast<JSDatabaseSync*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "DatabaseSync", "changeVersion");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSDatabaseSync::info());
    DatabaseSync& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    const String& oldVersion(exec->argument(0).isEmpty() ? String() : exec->argument(0).toString(exec)->value(exec));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    const String& newVersion(exec->argument(1).isEmpty() ? String() : exec->argument(1).toString(exec)->value(exec));
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    RefPtr<SQLTransactionSyncCallback> callback;
    if (!exec->argument(2).isUndefinedOrNull()) {
        if (!exec->uncheckedArgument(2).isFunction())
            return throwArgumentMustBeFunctionError(*exec, 2, "callback", "DatabaseSync", "changeVersion");
        callback = JSSQLTransactionSyncCallback::create(asObject(exec->uncheckedArgument(2)), castedThis->globalObject());
    }
    impl.changeVersion(oldVersion, newVersion, callback, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsDatabaseSyncPrototypeFunctionTransaction(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSDatabaseSync* castedThis = jsDynamicCast<JSDatabaseSync*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "DatabaseSync", "transaction");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSDatabaseSync::info());
    DatabaseSync& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    if (!exec->argument(0).isFunction())
        return throwArgumentMustBeFunctionError(*exec, 0, "callback", "DatabaseSync", "transaction");
    RefPtr<SQLTransactionSyncCallback> callback = JSSQLTransactionSyncCallback::create(asObject(exec->uncheckedArgument(0)), castedThis->globalObject());
    impl.transaction(callback, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsDatabaseSyncPrototypeFunctionReadTransaction(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSDatabaseSync* castedThis = jsDynamicCast<JSDatabaseSync*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "DatabaseSync", "readTransaction");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSDatabaseSync::info());
    DatabaseSync& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    if (!exec->argument(0).isFunction())
        return throwArgumentMustBeFunctionError(*exec, 0, "callback", "DatabaseSync", "readTransaction");
    RefPtr<SQLTransactionSyncCallback> callback = JSSQLTransactionSyncCallback::create(asObject(exec->uncheckedArgument(0)), castedThis->globalObject());
    impl.readTransaction(callback, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

bool JSDatabaseSyncOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSDatabaseSyncOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSDatabaseSync* jsDatabaseSync = jsCast<JSDatabaseSync*>(handle.slot()->asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsDatabaseSync->impl(), jsDatabaseSync);
    jsDatabaseSync->releaseImpl();
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7DatabaseSync@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore12DatabaseSyncE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject* globalObject, DatabaseSync* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSDatabaseSync>(globalObject, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7DatabaseSync@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore12DatabaseSyncE[2];
#if COMPILER(CLANG)
    // If this fails DatabaseSync does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(DatabaseSync), DatabaseSync_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // DatabaseSync has subclasses. If DatabaseSync has subclasses that get passed
    // to toJS() we currently require DatabaseSync you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createNewWrapper<JSDatabaseSync>(globalObject, impl);
}

DatabaseSync* toDatabaseSync(JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSDatabaseSync*>(value))
        return &wrapper->impl();
    return nullptr;
}

}

#endif // ENABLE(SQL_DATABASE)
