/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSSQLTransactionSync_h
#define JSSQLTransactionSync_h

#if ENABLE(SQL_DATABASE)

#include "JSDOMWrapper.h"
#include "SQLTransactionSync.h"

namespace WebCore {

class JSSQLTransactionSync : public JSDOMWrapper {
public:
    typedef JSDOMWrapper Base;
    static JSSQLTransactionSync* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<SQLTransactionSync> impl)
    {
        JSSQLTransactionSync* ptr = new (NotNull, JSC::allocateCell<JSSQLTransactionSync>(globalObject->vm().heap)) JSSQLTransactionSync(structure, globalObject, impl);
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static JSC::JSObject* getPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static void destroy(JSC::JSCell*);
    ~JSSQLTransactionSync();

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }


    // Custom functions
    JSC::JSValue executeSql(JSC::ExecState*);
    SQLTransactionSync& impl() const { return *m_impl; }
    void releaseImpl() { m_impl->deref(); m_impl = 0; }

    void releaseImplIfNotNull()
    {
        if (m_impl) {
            m_impl->deref();
            m_impl = 0;
        }
    }

private:
    SQLTransactionSync* m_impl;
protected:
    JSSQLTransactionSync(JSC::Structure*, JSDOMGlobalObject*, PassRefPtr<SQLTransactionSync>);

    void finishCreation(JSC::VM& vm)
    {
        Base::finishCreation(vm);
        ASSERT(inherits(info()));
    }

};

class JSSQLTransactionSyncOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, SQLTransactionSync*)
{
    DEPRECATED_DEFINE_STATIC_LOCAL(JSSQLTransactionSyncOwner, jsSQLTransactionSyncOwner, ());
    return &jsSQLTransactionSyncOwner;
}

inline void* wrapperContext(DOMWrapperWorld& world, SQLTransactionSync*)
{
    return &world;
}

WEBCORE_EXPORT JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, SQLTransactionSync*);
WEBCORE_EXPORT SQLTransactionSync* toSQLTransactionSync(JSC::JSValue);


} // namespace WebCore

#endif // ENABLE(SQL_DATABASE)

#endif
