/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(SHARED_WORKERS)

#include "JSSharedWorkerGlobalScope.h"

#include "EventListener.h"
#include "JSDOMBinding.h"
#include "JSEventListener.h"
#include "ScriptExecutionContext.h"
#include "SharedWorkerGlobalScope.h"
#include "URL.h"
#include <runtime/JSString.h>
#include <wtf/GetPtr.h>

#if ENABLE(SHARED_WORKERS)
#include "JSSharedWorkerGlobalScope.h"
#endif

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsSharedWorkerGlobalScopeName(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsSharedWorkerGlobalScopeOnconnect(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
void setJSSharedWorkerGlobalScopeOnconnect(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::EncodedJSValue);
#if ENABLE(SHARED_WORKERS)
JSC::EncodedJSValue jsSharedWorkerGlobalScopeSharedWorkerGlobalScopeConstructor(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
void setJSSharedWorkerGlobalScopeSharedWorkerGlobalScopeConstructor(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::EncodedJSValue);
#endif
JSC::EncodedJSValue jsSharedWorkerGlobalScopeConstructor(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);

class JSSharedWorkerGlobalScopeConstructor : public DOMConstructorObject {
private:
    JSSharedWorkerGlobalScopeConstructor(JSC::Structure*, JSDOMGlobalObject*);
    void finishCreation(JSC::VM&, JSDOMGlobalObject*);

public:
    typedef DOMConstructorObject Base;
    static JSSharedWorkerGlobalScopeConstructor* create(JSC::VM& vm, JSC::Structure* structure, JSDOMGlobalObject* globalObject)
    {
        JSSharedWorkerGlobalScopeConstructor* ptr = new (NotNull, JSC::allocateCell<JSSharedWorkerGlobalScopeConstructor>(vm.heap)) JSSharedWorkerGlobalScopeConstructor(structure, globalObject);
        ptr->finishCreation(vm, globalObject);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }
};

/* Hash table */

static const struct CompactHashIndex JSSharedWorkerGlobalScopeTableIndex[9] = {
    { -1, -1 },
    { 0, 8 },
    { 2, -1 },
    { 3, -1 },
    { -1, -1 },
    { -1, -1 },
    { -1, -1 },
    { -1, -1 },
    { 1, -1 },
};


static const HashTableValue JSSharedWorkerGlobalScopeTableValues[] =
{
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSharedWorkerGlobalScopeConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "name", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSharedWorkerGlobalScopeName), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "onconnect", DontDelete | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSharedWorkerGlobalScopeOnconnect), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSSharedWorkerGlobalScopeOnconnect) },
#if ENABLE(SHARED_WORKERS)
    { "SharedWorkerGlobalScope", DontEnum, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSharedWorkerGlobalScopeSharedWorkerGlobalScopeConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSSharedWorkerGlobalScopeSharedWorkerGlobalScopeConstructor) },
#else
    { 0, 0, NoIntrinsic, 0, 0 },
#endif
};

static const HashTable JSSharedWorkerGlobalScopeTable = { 4, 7, true, JSSharedWorkerGlobalScopeTableValues, 0, JSSharedWorkerGlobalScopeTableIndex };
const ClassInfo JSSharedWorkerGlobalScopeConstructor::s_info = { "SharedWorkerGlobalScopeConstructor", &Base::s_info, 0, CREATE_METHOD_TABLE(JSSharedWorkerGlobalScopeConstructor) };

JSSharedWorkerGlobalScopeConstructor::JSSharedWorkerGlobalScopeConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSSharedWorkerGlobalScopeConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, globalObject->prototype(), DontDelete | ReadOnly);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontDelete | DontEnum);
}

/* Hash table for prototype */

static const struct CompactHashIndex JSSharedWorkerGlobalScopePrototypeTableIndex[1] = {
    { -1, -1 },
};


static const HashTableValue JSSharedWorkerGlobalScopePrototypeTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSSharedWorkerGlobalScopePrototypeTable = { 0, 0, false, JSSharedWorkerGlobalScopePrototypeTableValues, 0, JSSharedWorkerGlobalScopePrototypeTableIndex };
WEBCORE_EXPORT const ClassInfo JSSharedWorkerGlobalScopePrototype::s_info = { "SharedWorkerGlobalScopePrototype", &Base::s_info, &JSSharedWorkerGlobalScopePrototypeTable, CREATE_METHOD_TABLE(JSSharedWorkerGlobalScopePrototype) };

WEBCORE_EXPORT const ClassInfo JSSharedWorkerGlobalScope::s_info = { "SharedWorkerGlobalScope", &Base::s_info, &JSSharedWorkerGlobalScopeTable, CREATE_METHOD_TABLE(JSSharedWorkerGlobalScope) };

JSSharedWorkerGlobalScope::JSSharedWorkerGlobalScope(VM& vm, Structure* structure, PassRefPtr<SharedWorkerGlobalScope> impl)
    : JSWorkerGlobalScope(vm, structure, impl)
{
}

bool JSSharedWorkerGlobalScope::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSSharedWorkerGlobalScope* thisObject = jsCast<JSSharedWorkerGlobalScope*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSSharedWorkerGlobalScope, Base>(exec, JSSharedWorkerGlobalScopeTable, thisObject, propertyName, slot);
}

EncodedJSValue jsSharedWorkerGlobalScopeName(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSSharedWorkerGlobalScope* castedThis = toJSSharedWorkerGlobalScope(JSValue::decode(thisValue));
    SharedWorkerGlobalScope& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.name());
    return JSValue::encode(result);
}


EncodedJSValue jsSharedWorkerGlobalScopeOnconnect(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSSharedWorkerGlobalScope* castedThis = toJSSharedWorkerGlobalScope(JSValue::decode(thisValue));
    UNUSED_PARAM(exec);
    SharedWorkerGlobalScope& impl = castedThis->impl();
    if (EventListener* listener = impl.onconnect()) {
        if (const JSEventListener* jsListener = JSEventListener::cast(listener)) {
            if (JSObject* jsFunction = jsListener->jsFunction(&impl))
                return JSValue::encode(jsFunction);
        }
    }
    return JSValue::encode(jsNull());
}


#if ENABLE(SHARED_WORKERS)
EncodedJSValue jsSharedWorkerGlobalScopeSharedWorkerGlobalScopeConstructor(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSSharedWorkerGlobalScope* castedThis = toJSSharedWorkerGlobalScope(JSValue::decode(thisValue));
    return JSValue::encode(JSSharedWorkerGlobalScope::getConstructor(exec->vm(), castedThis->globalObject()));
}

#endif

EncodedJSValue jsSharedWorkerGlobalScopeConstructor(ExecState* exec, JSObject*, EncodedJSValue thisValue, PropertyName)
{
    JSSharedWorkerGlobalScope* domObject = toJSSharedWorkerGlobalScope(JSValue::decode(thisValue));
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSSharedWorkerGlobalScope::getConstructor(exec->vm(), domObject->globalObject()));
}

void setJSSharedWorkerGlobalScopeOnconnect(ExecState* exec, JSObject* baseObject, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    JSValue value = JSValue::decode(encodedValue);
    UNUSED_PARAM(baseObject);
    JSSharedWorkerGlobalScope* castedThis = toJSSharedWorkerGlobalScope(JSValue::decode(thisValue));
    UNUSED_PARAM(exec);
    SharedWorkerGlobalScope& impl = castedThis->impl();
    impl.setOnconnect(createJSAttributeEventListener(exec, value, castedThis));
}


#if ENABLE(SHARED_WORKERS)
void setJSSharedWorkerGlobalScopeSharedWorkerGlobalScopeConstructor(ExecState* exec, JSObject* baseObject, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    JSValue value = JSValue::decode(encodedValue);
    UNUSED_PARAM(baseObject);
    JSSharedWorkerGlobalScope* castedThis = toJSSharedWorkerGlobalScope(JSValue::decode(thisValue));
    // Shadowing a built-in constructor
    castedThis->putDirect(exec->vm(), Identifier(exec, "SharedWorkerGlobalScope"), value);
}

#endif

JSValue JSSharedWorkerGlobalScope::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSSharedWorkerGlobalScopeConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}

SharedWorkerGlobalScope* toSharedWorkerGlobalScope(JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSSharedWorkerGlobalScope*>(value))
        return &wrapper->impl();
    return nullptr;
}

}

#endif // ENABLE(SHARED_WORKERS)
