/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSWorker_h
#define JSWorker_h

#include "JSEventTarget.h"
#include "Worker.h"

namespace WebCore {

class JSWorker : public JSEventTarget {
public:
    typedef JSEventTarget Base;
    static JSWorker* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<Worker> impl)
    {
        JSWorker* ptr = new (NotNull, JSC::allocateCell<JSWorker>(globalObject->vm().heap)) JSWorker(structure, globalObject, impl);
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static JSC::JSObject* getPrototype(JSC::VM&, JSC::JSGlobalObject*);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, JSC::JSGlobalObject*);

    // Custom functions
    JSC::JSValue postMessage(JSC::ExecState*);
    Worker& impl() const
    {
        return static_cast<Worker&>(Base::impl());
    }
protected:
    JSWorker(JSC::Structure*, JSDOMGlobalObject*, PassRefPtr<Worker>);

    void finishCreation(JSC::VM& vm)
    {
        Base::finishCreation(vm);
        ASSERT(inherits(info()));
    }

};

class JSWorkerOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, Worker*)
{
    DEPRECATED_DEFINE_STATIC_LOCAL(JSWorkerOwner, jsWorkerOwner, ());
    return &jsWorkerOwner;
}

inline void* wrapperContext(DOMWrapperWorld& world, Worker*)
{
    return &world;
}

WEBCORE_EXPORT JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, Worker*);
WEBCORE_EXPORT Worker* toWorker(JSC::JSValue);

// Custom constructor
JSC::EncodedJSValue JSC_HOST_CALL constructJSWorker(JSC::ExecState*);


} // namespace WebCore

#endif
